"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = require("axios");
var UrlHelper_1 = require("./helpers/UrlHelper");
var Api = /** @class */ (function () {
    function Api(properties) {
        if (properties === void 0) { properties = {}; }
        this.headers = {};
        Object.assign(this, properties);
    }
    Object.defineProperty(Api.prototype, "path", {
        get: function () {
            return "";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Api.prototype, "base", {
        get: function () {
            return this._base || api._base || "/";
        },
        set: function (value) {
            this._base = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Api.prototype, "mixedHeaders", {
        get: function () {
            return Object.assign({}, api.headers, this.headers);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Api.prototype, "baseUrl", {
        get: function () {
            var path = this.path.length ? UrlHelper_1.trailUrl(this.path) : "";
            return UrlHelper_1.trailUrl(this.base) + path;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Api.prototype, "jwtToken", {
        get: function () {
            return this.mixedHeaders.Authorization;
        },
        set: function (token) {
            this.headers.Authorization = "Bearer " + token;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Api.prototype, "csrfToken", {
        get: function () {
            return this.mixedHeaders["X-CSRF-Token"];
        },
        set: function (token) {
            this.headers["X-CSRF-Token"] = token;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Api.prototype, "http", {
        get: function () {
            return axios_1.default.create({ baseURL: this.baseUrl, headers: this.mixedHeaders });
        },
        enumerable: true,
        configurable: true
    });
    return Api;
}());
exports.Api = Api;
var api = new Api();
exports.default = api;
//# sourceMappingURL=Api.js.map