import Hash from "./Hash";
export declare type ChangeListener<T> = (key: any, value: T) => any;
export default class Cache<T> {
    enabled: boolean;
    values: Hash<T>;
    changeListeners: ChangeListener<T>[];
    get(key: string): T;
    set(key: string, value: T): T;
    destroy(key: string): void;
    clear(): void;
    onChange(callback: ChangeListener<T>): void;
    protected emitChange(key: string, value: T): void;
}
