"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Cache = /** @class */ (function () {
    function Cache() {
        this.enabled = true;
        this.values = {};
        this.changeListeners = [];
    }
    Cache.prototype.get = function (key) {
        return this.values[key];
    };
    Cache.prototype.set = function (key, value) {
        if (this.enabled) {
            this.values[key] = value;
            this.emitChange(key, value);
        }
        return value;
    };
    Cache.prototype.destroy = function (key) {
        delete this.values[key];
    };
    Cache.prototype.clear = function () {
        this.values = {};
    };
    Cache.prototype.onChange = function (callback) {
        this.changeListeners.push(callback);
    };
    Cache.prototype.emitChange = function (key, value) {
        this.changeListeners.forEach(function (callback) { return callback(key, value); });
    };
    return Cache;
}());
exports.default = Cache;
//# sourceMappingURL=Cache.js.map