import Store, { FetchOptions, FetchListOptions, Options, ActOptions } from "./Store";
import Hash from "./Hash";
export interface IModel {
    key: string;
}
export default class Model implements IModel {
    keyColumn: string;
    path: string;
    private _singular;
    private static _store;
    private static _reflector;
    static storeProperties: Hash<any>;
    readonly self: typeof Model;
    static readonly reflector: Model;
    readonly store: Store<this>;
    static readonly hasStore: boolean;
    static store: Store<Model>;
    key: any;
    static key(value: any | IModel): string;
    singular: string;
    readonly foreignName: string;
    foreignKey(foreignModel: typeof Model): any;
    readonly map: Hash<any>;
    private mappingFor(attribute);
    private transformer(attribute, type);
    private transform(attribute, value, type);
    normalized(attribute: string, value: any): any;
    denormalized(attribute: string, value: any): any;
    set(values: Hash<any>): this;
    duplicate(): this;
    static make(values: Hash<any>): Model;
    static makeArray(valuesArray: Hash<any>[]): Model[];
    reload(): Promise<this>;
    static find(key: any, options?: FetchOptions): Promise<Model>;
    static all(options?: FetchOptions): Promise<Model[]>;
    create(options?: Options): Promise<this>;
    static create(values: Hash<any>, options?: Options): Promise<Model>;
    update(options?: Options): Promise<this>;
    static update(key: any, values: Hash<any>, options?: Options): Promise<Model>;
    save(options?: Options): Promise<this>;
    static save(values: Hash<any>, options?: Options): Promise<Model>;
    destroy(options?: Options): Promise<any>;
    static destroy(key: any, options?: Options): Promise<any>;
    belongsTo(foreignModel: typeof Model, options?: FetchOptions): Promise<Model>;
    belongsToMany(foreignModel: typeof Model, options?: FetchListOptions): Promise<Model[]>;
    static belongsToMany(foreignModel: typeof Model, value: any, options?: FetchListOptions): Promise<Model[]>;
    hasOne(foreignModel: typeof Model, options?: FetchListOptions): Promise<Model>;
    static hasOne(foreignModel: typeof Model, key: any, options?: FetchListOptions): Promise<Model | null>;
    hasMany(foreignModel: typeof Model, options?: FetchListOptions): Promise<Model[]>;
    static hasMany(foreignModel: typeof Model, key: any, options?: FetchListOptions): Promise<Model[]>;
    act(options?: ActOptions): Promise<any>;
    static act(options?: ActOptions): Promise<any>;
}
