"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Store_1 = require("./Store");
var StringHelper_1 = require("./helpers/StringHelper");
var Model = /** @class */ (function () {
    function Model() {
        this.keyColumn = "id";
    }
    Object.defineProperty(Model.prototype, "self", {
        get: function () {
            return this.constructor;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Model, "reflector", {
        get: function () {
            var reflector = this._reflector;
            if (reflector && reflector instanceof this) {
                return reflector;
            }
            return (this._reflector = new this());
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Model.prototype, "store", {
        get: function () {
            return this.constructor.store;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Model, "hasStore", {
        get: function () {
            return !!this._store;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Model, "store", {
        get: function () {
            return (this._store = this._store || new Store_1.default(this, this.storeProperties));
        },
        set: function (value) {
            this._store = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Model.prototype, "key", {
        get: function () {
            return this[this.keyColumn];
        },
        set: function (value) {
            this[this.keyColumn] = value;
        },
        enumerable: true,
        configurable: true
    });
    Model.key = function (value) {
        if (value === null || typeof value === "undefined") {
            throw new Error("Unable to resolve key `" + value + "`");
        }
        if (typeof value === "object") {
            return value.key;
        }
        return value;
    };
    Object.defineProperty(Model.prototype, "singular", {
        get: function () {
            return this._singular || this.path.substring(0, this.path.length - 1);
        },
        set: function (value) {
            this._singular = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Model.prototype, "foreignName", {
        get: function () {
            return this.singular + "_" + this.keyColumn;
        },
        enumerable: true,
        configurable: true
    });
    Model.prototype.foreignKey = function (foreignModel) {
        return this[foreignModel.reflector.foreignName];
    };
    Object.defineProperty(Model.prototype, "map", {
        get: function () {
            var _this = this;
            var result = {};
            Object.keys(this).forEach(function (attribute) {
                var mapping = _this.mappingFor(attribute);
                if (mapping !== null) {
                    result[attribute] = mapping;
                }
            });
            return result;
        },
        enumerable: true,
        configurable: true
    });
    Model.prototype.mappingFor = function (attribute) {
        var value = this[attribute];
        if (typeof value === "object" || typeof value === "function" || this.self.reflector.hasOwnProperty(attribute)) {
            return null;
        }
        return this.denormalized(attribute, value);
    };
    Model.prototype.transformer = function (attribute, type) {
        var underscored = type + "_" + attribute;
        if (this[underscored]) {
            return underscored;
        }
        var camel = type + StringHelper_1.camelize(attribute);
        if (this[camel]) {
            return camel;
        }
    };
    Model.prototype.transform = function (attribute, value, type) {
        var transformer = this.transformer(attribute, type);
        return transformer ? this[transformer](value) : value;
    };
    Model.prototype.normalized = function (attribute, value) {
        return this.transform(attribute, value, "normalize");
    };
    Model.prototype.denormalized = function (attribute, value) {
        return this.transform(attribute, value, "denormalize");
    };
    Model.prototype.set = function (values) {
        var _this = this;
        Object.keys(values).forEach(function (key) {
            _this[key] = _this.normalized(key, values[key]);
        });
        return this;
    };
    Model.prototype.duplicate = function () {
        var result = Object.assign(new this.self(), this);
        delete result[this.keyColumn];
        return result;
    };
    Model.make = function (values) {
        return new this().set(values);
    };
    Model.makeArray = function (valuesArray) {
        var _this = this;
        return valuesArray.map(function (values) { return _this.make(values); });
    };
    Model.prototype.reload = function () {
        return this.self.find(this.key);
    };
    Model.find = function (key, options) {
        return this.store.get(key, options);
    };
    Model.all = function (options) {
        return this.store.index(options);
    };
    Model.prototype.create = function (options) {
        return this.self.create(this.map, options);
    };
    Model.create = function (values, options) {
        return this.store.create(values, options);
    };
    Model.prototype.update = function (options) {
        return this.self.update(this.key, this.map, options);
    };
    Model.update = function (key, values, options) {
        return this.store.update(key, values, options);
    };
    Model.prototype.save = function (options) {
        return this.self.save(this.map, options);
    };
    Model.save = function (values, options) {
        if (values[this.reflector.keyColumn]) {
            return this.update(values[this.reflector.keyColumn], values, options);
        }
        return this.create(values, options);
    };
    Model.prototype.destroy = function (options) {
        return this.self.destroy(this.key, options);
    };
    Model.destroy = function (key, options) {
        return this.store.destroy(key, options);
    };
    Model.prototype.belongsTo = function (foreignModel, options) {
        return foreignModel.find(this.foreignKey(foreignModel), options);
    };
    Model.prototype.belongsToMany = function (foreignModel, options) {
        return this.self.belongsToMany(foreignModel, this.foreignKey(foreignModel), options);
    };
    Model.belongsToMany = function (foreignModel, value, options) {
        return foreignModel.hasMany(this, value, options);
    };
    Model.prototype.hasOne = function (foreignModel, options) {
        return this.self.hasOne(foreignModel, this.key, options);
    };
    Model.hasOne = function (foreignModel, key, options) {
        return __awaiter(this, void 0, void 0, function () {
            var items;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.hasMany(foreignModel, key, options)];
                    case 1:
                        items = _a.sent();
                        return [2 /*return*/, items.length ? items[0] : null];
                }
            });
        });
    };
    Model.prototype.hasMany = function (foreignModel, options) {
        return this.self.hasMany(foreignModel, this.key, options);
    };
    Model.hasMany = function (foreignModel, key, options) {
        return this.store.foreign(foreignModel, key, options);
    };
    Model.prototype.act = function (options) {
        if (!options) {
            options = {};
        }
        options.url = options.url || this.key;
        return this.self.act(options);
    };
    Model.act = function (options) {
        return this.store.act(options);
    };
    Model.storeProperties = {};
    return Model;
}());
exports.default = Model;
//# sourceMappingURL=Model.js.map