"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ModelResponse = /** @class */ (function () {
    function ModelResponse(model, response, callback) {
        this.model = model;
        this.response = response;
        this.callback = callback;
    }
    Object.defineProperty(ModelResponse.prototype, "data", {
        get: function () {
            if (this.callback) {
                return this.callback(this.response).data;
            }
            return this.response.data;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ModelResponse.prototype, "asInstance", {
        get: function () {
            return this.model.make(this.data);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ModelResponse.prototype, "asArray", {
        get: function () {
            var data = this.data;
            if (!Array.isArray(data)) {
                data = [data];
            }
            return this.model.makeArray(data);
        },
        enumerable: true,
        configurable: true
    });
    return ModelResponse;
}());
exports.default = ModelResponse;
//# sourceMappingURL=ModelResponse.js.map