import Cache from "./Cache";
import StoreCacheCascade from "./StoreCacheCascade";
import Model from "./Model";
export default class StoreCache<T extends Model> {
    objects: Cache<T>;
    lists: Cache<T[]>;
    promises: Cache<Promise<T | T[]>>;
    constructor();
    readonly cascade: StoreCacheCascade<T>;
    private clearLists();
    private bindListClearance();
    private schedulePromiseDeletion(key, promise);
    private bindPromiseDeletion();
}
