"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Cache_1 = require("./Cache");
var StoreCacheCascade_1 = require("./StoreCacheCascade");
var StoreCache = /** @class */ (function () {
    function StoreCache() {
        this.objects = new Cache_1.default();
        this.lists = new Cache_1.default();
        this.promises = new Cache_1.default();
        this.bindListClearance();
        this.bindPromiseDeletion();
    }
    Object.defineProperty(StoreCache.prototype, "cascade", {
        get: function () {
            return new StoreCacheCascade_1.default(this);
        },
        enumerable: true,
        configurable: true
    });
    StoreCache.prototype.clearLists = function () {
        this.lists.clear();
    };
    StoreCache.prototype.bindListClearance = function () {
        this.objects.onChange(this.clearLists.bind(this));
    };
    StoreCache.prototype.schedulePromiseDeletion = function (key, promise) {
        var _this = this;
        var removePromise = function () { return _this.promises.destroy(key); };
        promise.then(removePromise, removePromise);
    };
    StoreCache.prototype.bindPromiseDeletion = function () {
        this.promises.onChange(this.schedulePromiseDeletion.bind(this));
    };
    return StoreCache;
}());
exports.default = StoreCache;
//# sourceMappingURL=StoreCache.js.map