import StoreCache from "./StoreCache";
import Model from "./Model";
import PromiseCascade, { PromiseFunction } from "promise-cascade";
export interface StoreCascadeOptions {
    ignoreCache?: boolean;
}
export interface StoreCascadeListOptions extends StoreCascadeOptions {
    completeItems?: boolean;
}
export default class StoreCacheCascade<T extends Model> extends PromiseCascade {
    cache: StoreCache<T>;
    constructor(cache: StoreCache<T>);
    protected promiseCallback(key: string, callback: PromiseFunction): Promise<T | T[]>;
    promise(key: string): this;
    protected objectCallback(key: any, options: StoreCascadeOptions, callback: PromiseFunction): Promise<T>;
    object(key: any, options: StoreCascadeOptions): this;
    protected listCallback(key: string, options: StoreCascadeListOptions, callback: PromiseFunction): Promise<T[]>;
    list(key: string, options?: StoreCascadeListOptions): this;
}
