"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function buildUrl(options, defaultUrl) {
    if (defaultUrl === void 0) { defaultUrl = ""; }
    var url = options.url || defaultUrl;
    if (options.queryParams) {
        url += "?" + buildEncodedQueryParams(options.queryParams);
    }
    return url;
}
exports.buildUrl = buildUrl;
function buildEncodedQueryParams(queryParams) {
    if (typeof queryParams === "string") {
        return queryParams;
    }
    return Object.keys(queryParams)
        .map(function (key) { return encodeURIComponent(key) + "=" + encodeURIComponent(queryParams[key]); })
        .join("&");
}
exports.buildEncodedQueryParams = buildEncodedQueryParams;
function trailUrl(url) {
    return url.endsWith("/") ? url : url + "/";
}
exports.trailUrl = trailUrl;
//# sourceMappingURL=UrlHelper.js.map